//$Header: W:/CVSROOT/js/NameAllColors/Name\040All\040Colors.js,v 1.3 2004/09/24 16:22:37 iharlamov Exp $
if (version.slice(0,2) < 11) {
error++;
alert("Etot skript rabotaet tolko v Illustrator CS i moget ne rabotat v vashei versii.");
}

if ( app.documents.length > 0 && app.activeDocument.pathItems.length > 0){

   doc = app.activeDocument;
   pathItems=app.activeDocument.pathItems;
   for (i=0; i < pathItems.length ; i++){
      if (pathItems[i].filled && !inSwatches(pathItems[i].fillColor)){
         addSwatch(pathItems[i].fillColor);
      }
      if (pathItems[i].stroked && !inSwatches(pathItems[i].strokeColor)){
         addSwatch(pathItems[i].strokeColor);
      }

   }
}

function addSwatch(SWobject) {
   SWname = SwatchName(SWobject);
   SW = activeDocument.swatches.add();
   SW.name = SWname;
   SW.color = SWobject;
}

function colorsIdentical (Col1, Col2){
   var compOK = 0;
   if (Col1.typename == Col2.typename ) {
         Tint1 = 100;
         Tint2 = 100;
      if (Col1.typename == "SpotColor") {
         Tint1 = Col1.tint;
         Tint2 = Col2.tint;

         Col1 = Col1.spot.color;
         Col2 = Col2.spot.color;
      }

      if (Col1.typename == "CMYKColor"){
         if (Col1.cyan == Col2.cyan && Col1.magenta == Col2.magenta && Col1.yellow == Col2.yellow && Col1.black == Col2.black) { compOK = 1; }
      }

      if (Col1.typename == "RGBColor"){
         if (Col1.red == Col2.red && Col1.green == Col2.green && Col1.blue == Col2.blue ) { compOK = 1; }
      }

      if (Col1.typename == "GrayColor"){
         if (Col1.gray == Col2.gray ) { compOK = 1; }
      }

      if (Col1.typename == "GradientColor"){
         if (Col1.gradient.name == Col2.gradient.name ) { compOK = 1; }
      }

      if (compOK ==1 && Tint1 != Tint2) { 
         compOK = 0; 
      }
   }

   if (compOK == 1 ) {
      return 1; 
   } else {
      return 0; 
   }
} 

function SwatchName (SWobject){
   SWname = "";
   if (SWobject.typename == "SpotColor"){
      SWname = SWobject.spot.name;
   }
   if (SWobject.typename == "GradientColor"){
      SWname = SWobject.gradient.name;
   }
   if (SWobject.typename == "CMYKColor"){
      SWname = "C="+Math.round(SWobject.cyan)+" M="+Math.round(SWobject.magenta)+" Y="+Math.round(SWobject.yellow)+" K="+Math.round(SWobject.black);
   }
   if (SWobject.typename == "RGBColor"){
      SWname = "R="+Math.round(SWobject.red,2)+" G="+Math.round(SWobject.green,2)+" B="+Math.round(SWobject.blue);
   }
   if (SWobject.typename == "GrayColor"){
      SWname = "Gray="+Math.round(SWobject.gray,2);
   }
return SWname;
}

function inSwatches (Color){
   for (j = 0; j < activeDocument.swatches.length; j++)
      if (colorsIdentical(activeDocument.swatches[j].color,Color)) return true;

   return false;
}
